﻿using System.Collections.Generic;
using System.Windows;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace WpfApplication4
{
    public partial class MainWindow : Window
    {
        Stack<int> selectedIndex = new Stack<int>(1);
        ObservableCollection<Person> source = new ObservableCollection<Person> 
        { 
            new Person { Name = "person1" }, new Person { Name = "person2" }, 
            new Person { Name = "person3" },new Person{Name="person4"},
            new Person { Name="person5"},new Person{Name="person6"} 
        };

        public MainWindow()
        {
            InitializeComponent();
            xamCombo.ItemsSource = source;
        }

        private void xamCombo_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            if (xamCombo.SelectedIndex != -1)
            {
                if (selectedIndex.Count == 0)
                    selectedIndex.Push(xamCombo.SelectedIndex);
                else
                {
                    selectedIndex.Clear();
                    selectedIndex.Push(xamCombo.SelectedIndex);
                }

            }
        }

        private void xamCombo_LostFocus(object sender, RoutedEventArgs e)
        {
            if (selectedIndex.Count == 0)
                return;
            else
                source[selectedIndex.Pop()].Name = xamCombo.Text;
        }
    }

    public class Person : INotifyPropertyChanged
    {
        string name;
        public string Name 
        {
            get
            {
                return this.name;
            }
            set
            {
                if (this.name != value)
                {
                    this.name = value;
                    OnPropertyChanged("Name");
                }
            }
        }

        public override string ToString()
        {
            return this.Name;
        }

        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged(string prName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(prName));
        }
    }
}
